using System.Collections.ObjectModel;
using System.Threading.Tasks;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Field
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region Field

    /// <summary>
    /// ߰  
    /// </summary>
    private bool hasMoreData = true;

    /// <summary>
    /// ۾ 
    /// </summary>
    private bool isBusy = false;

    /// <summary>
    ///  
    /// </summary>
    private int currentPage = 0;

    /// <summary>
    ///  ׸ 
    /// </summary>
    private readonly int itemCountPerPage = 10;

    /// <summary>
    /// ִ  
    /// </summary>
    private readonly int maximumPageCount = 100;

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ڿ ÷ - StringCollection

    /// <summary>
    /// ڿ ÷
    /// </summary>
    public ObservableCollection<string> StringCollection { get; } = new ObservableCollection<string>();

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        Loaded                        += Page_Loaded;
        this.scrollViewer.ViewChanged += scrollViewer_ViewChanged;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region  ε óϱ - Page_Loaded(sender, e)

    /// <summary>
    ///  ε óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private async void Page_Loaded(object sender, RoutedEventArgs e)
    {
        await LoadInitialDataAsync();
    }

    #endregion
    #region ũ    óϱ - scrollViewer_ViewChanged(sender, e)

    /// <summary>
    /// ũ    óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private async void scrollViewer_ViewChanged(object sender, ScrollViewerViewChangedEventArgs e)
    {
        if(!e.IsIntermediate)
        {
            ScrollViewer scrollViewer = sender as ScrollViewer;

            double distanceToEnd = scrollViewer.ExtentHeight - (scrollViewer.VerticalOffset + scrollViewer.ViewportHeight);

            if(distanceToEnd <= 2.0 * scrollViewer.ViewportHeight && this.hasMoreData && !this.isBusy)
            {
                await LoadMoreDataAsync();
            }
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region ߰  εϱ (񵿱) - LoadMoreDataAsync()

    /// <summary>
    /// ߰  εϱ (񵿱)
    /// </summary>
    /// <returns>½ũ</returns>
    private async Task LoadMoreDataAsync()
    {
        if(this.isBusy)
        {
            return;
        }

        this.isBusy = true;

        this.progressRing.IsActive   = true;
        this.progressRing.Visibility = Visibility.Visible;

        await Task.Delay(1000); //  ε ùķ̼ϱ  

        for(int i = 0; i < this.itemCountPerPage; i++)
        {
            StringCollection.Add($"׸ {this.currentPage * this.itemCountPerPage + i + 1}");
        }

        this.currentPage++;

        this.hasMoreData = this.currentPage < this.maximumPageCount;

        this.progressRing.IsActive   = false;
        this.progressRing.Visibility = Visibility.Collapsed;

        this.isBusy = false;
    }

    #endregion
    #region ʿ ߰  εϱ (񵿱) - LoadMoreDataIfNeededAsync()

    /// <summary>
    /// ʿ ߰  εϱ (񵿱)
    /// </summary>
    /// <returns></returns>
    private async Task LoadMoreDataIfNeededAsync()
    {
        // ScrollViewer ViewportHeight 0 ƴ    Ѵ.
        while(this.scrollViewer.ViewportHeight == 0)
        {
            await Task.Delay(50);
        }

        while(this.scrollViewer.ExtentHeight <= this.scrollViewer.ViewportHeight && this.hasMoreData)
        {
            await LoadMoreDataAsync();
        }
    }

    #endregion
    #region ʱ  εϱ (񵿱) - LoadInitialDataAsync()

    /// <summary>
    /// ʱ  εϱ (񵿱)
    /// </summary>
    /// <returns>½ũ</returns>
    private async Task LoadInitialDataAsync()
    {
        await LoadMoreDataAsync();

        await LoadMoreDataIfNeededAsync();
    }

    #endregion
}